/*********************************************************************

          ps.h: PolhemusSensor device driver
                    for ISOTRAK(II) (made from FASTRAK ver.)
                                        Kenji with Tail

*********************************************************************/


#ifndef _PS_H_
#define _PS_H_

#define POSORI_NUM_PS 6
typedef float PosOri_ps[POSORI_NUM_PS];

/* Init_ps() initialize PolhemusSensor
 *    Returns False (zero) if failed
 *    Returns True (non-zero) if successful
 *    give port:  serial port device file name, ex "/dev/ttyd1"...
 *         baud:  baud rate, ex 38400...
 */
int Init_ps(char *port, long int baud);

/* Close_ps() closes the port opened by Init_ps()
 *    Returns False (zero) if failed
 *    Returns True (non-zero) if successful
 */
int Close_ps(void);

/* Reset_ps() resets ps
 *    Returns False (zero) if failed
 *    Returns True (non-zero) if successful
 */
int Reset_ps(void);

/* Request_ps() requests position and orient
 *    Returns 1 or 2 if station#1 or 2 is changed
 *    Returns    0   if station#1 is stylus and button is ON
 *    Returns   -1   if failed
 *    give p*:       position/orient structur.
 */
int Request_ps(PosOri_ps p1, PosOri_ps p2);

/* dummy for FASTRAK ver. */
#define SetStation_ps(stn, act) ;
#define PosRequest_ps(p1, p2, p3, p4) Request_ps(p1, p2);

#endif

