/*********************************************************************

          sampleps.c: PolhemusSensor device driver
                       sample program
                                        Kenji with Tail

*********************************************************************/
/*
cc *.c -L/usr/share/src/OpenGL/toolkits/lib32 \
 -I/usr/share/src/OpenGL/toolkits/include \
 -lglut -lGLU -lGL -lXmu -lX11 -lm libPs.a
*/


#include <stdio.h>
#include <math.h>
#include <GL/glut.h>
#define PI 3.141592

/* ؤäդΤ󤯤롼 */
#include "ps.h"
/* ȤꤢǤäפä 38400ܡ */
#define BAUD 38400



#define GL_SAMPLE
/* ========== GL ط ========== */
#ifdef GL_SAMPLE
void idle(void)
{
  glutPostRedisplay();
}

/*  */
void drawobj(void)
{
  int i;
  static int flag = 0;
#define DIV 36
  static GLdouble vertex[DIV+1][3];

  /* ܤθƽлΤ߽ */
  if (flag == 0) {
    for (i = 0; i < DIV; i++){
      vertex[i][0] = cos(PI * 2 * i / DIV);
      vertex[i][1] = sin(PI * 2 * i / DIV);
      vertex[i][2] = 0;
    }
    vertex[i][0] = vertex[0][0];
    vertex[i][1] = vertex[0][1];
    vertex[i][2] = vertex[0][2];
    flag = 1;
  }
    
  /* ºݤ */
  glBegin(GL_QUADS);
  for (i = 0; i < DIV - 1 /* 虜ȡ-1 */; i++) {
    glNormal3dv(vertex[i]);
    glVertex3d(vertex[i][0], vertex[i][1], 2.0);
    glVertex3dv(vertex[i]);
    glNormal3dv(vertex[i+1]);
    glVertex3dv(vertex[i+1]);
    glVertex3d(vertex[i+1][0], vertex[i+1][1], 2.0);
  }
  glEnd();
}

void display(void)
{
  int i, j;
  static int r = 0;
  PosOri_ps p1, p2;

  /* ɸ */
  GLdouble vertex[][3] = {
    { 1.0, -.1, 1.0 }, { 1.0, -.1,-1.0},
    {-1.0, -.1,-1.0 }, {-1.0, -.1, 1.0},
    { 0.0, 1.0, 0.0 } /* <- ˡ٥ȥ */
  };
  GLfloat lpos[4] = {0.0, 2.5, 5.0, 0.0};
  GLfloat mcolr[4] = {0.7, 0.2, 0.2, 1.0};
  GLfloat mcolg[4] = {0.2, 0.7, 0.2, 1.0};
  GLfloat mcolb[4] = {0.2, 0.2, 0.7, 1.0};
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  /* ޥȥꥯ¸(ޤǤʤ) */
  glPushMatrix();

  glLightfv(GL_LIGHT0, GL_POSITION, lpos);

  /*  */
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mcolb);
  glBegin(GL_QUADS);
  glNormal3dv(vertex[4]);
  for (i = 0; i < 4; i++){
    glVertex3dv(vertex[i]);
  }
  glEnd();
  
  if( Request_ps(p1, p2) == -1){
      fprintf( stderr, "Cannot get isotrak data\n");
  }
  glTranslated(-p1[1]/5, -p1[2]/5, p1[0]/5-5); /* XYZ  */
  glRotated(-p1[3], 0,1,0);
  glRotated(-p1[4], 1,0,0);
  glRotated( p1[5]+90, 0,0,1);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mcolg);
  drawobj(); 
  glPopMatrix();

  glutSwapBuffers();
}

void resize(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30.0, (GLdouble)w/h, 1.0, 100.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0.0, 8.0, 10.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
}

void keyboard(unsigned char key, int x, int y)
{
  if (key == '\033'){
    /* close Isotrak */
    Close_ps();
    exit(0);
  }
}
#endif
/* ========== ޤ GL ط ========== */


void main (int argc, char* argv[])
{
  PosOri_ps   p, p2;
  int         i;
  
  /* ݡ2 У Ҥ餯 */
  if( ! Init_ps( "/dev/ttyd2", BAUD ) ) {
    fprintf( stderr, "%s: (;;)Cannot open the port\n", argv[0]);
    exit (0);
  }

#ifdef GL_SAMPLE
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  glutCreateWindow(argv[0]);
  glClearColor(1.0, 1.0, 1.0, 0.0);
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle);
  glutReshapeFunc(resize);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glutMainLoop();
#endif

  /* ʤɤߤƤߤ */
  for( i=0; i<100; i++ ){
    Request_ps( p, p2 );
    fprintf( stdout, "%8.2f %8.2f %8.2f %8.2f %8.2f %8.2f\n",
	     p[0], p[1], p[2], p[3], p[4], p[5] );
    
    /* fflush(stdout);*/
  }
  
  /*  Ȥޤ礦 */
  Close_ps();
  
}

